<template>
  <div class="register-photo">
    <el-container>
      <div class="form-container">
        <el-aside>
            <div></div>
        </el-aside>
        <el-main>
          <h2 align="center"><strong>卡路里大作战</strong></h2>
            <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="100px" class="demo-ruleForm">
              <el-form-item label="联系方式" prop="userPhorEm">
                  <el-input v-model="ruleForm.userPhorEm" placeholder="请输入手机号或邮箱">
                    <el-select v-model="ruleForm.selectWay" slot="prepend" placeholder="请选择">
                      <el-option label="手机" value="选项1"></el-option>
                      <el-option label="邮箱" value="选项2"></el-option>
                    </el-select>
                  </el-input>
              </el-form-item>
              <el-form-item label="用户账号" prop="userName">
                  <el-input v-model="ruleForm.userName" placeholder="请输入用户账号"></el-input>
              </el-form-item>
              <el-form-item label="用户密码" prop="userPassword">
                  <el-input type="password" v-model="ruleForm.userPassword" placeholder="请输入密码"></el-input>
              </el-form-item>
              <el-form-item label="确认密码" prop="userRepassword">
                  <el-input type="password" v-model="ruleForm.userRepassword" placeholder="请再次输入密码"></el-input>
              </el-form-item>
              <el-form-item label="验证码" prop="verifyCode">
                <div>
                  <el-input style="width:50%" v-model="ruleForm.verifyCode" placeholder="请输入验证码"></el-input>
                  <el-button style="position: absolute;right:0px" type="primary" plain :disabled="disabled" @click="getVerityCode">{{valiBtn}}</el-button>
                </div>
              </el-form-item>
            </el-form>
            <div align="center">
              <el-popover placement="top" width="200" v-model="regvisible" title="注册失败！">
                <p>{{registerMsg}}</p>
                <div style="text-align: right; margin: 0">
                  <el-button type="primary" size="mini" @click="regvisible = false">确定</el-button>
                </div>
                <el-button slot="reference" type="danger" @click="submitForm">立即注册</el-button>
              </el-popover>
              </div>
            <div align="center"><el-link type="info" align="center" :underline="false" @click="toLogin">已经有账号了?直接登陆!</el-link></div>
        </el-main>
      </div>
    </el-container>
  </div>
</template>
<script>
import registerService from '@/services/registerService'

export default {
  name: 'Register',
  data () {
    var validatapass2 = (rule, value, callback) => {
      if (value === '') {
        this.registerMsg = '请再次输入密码'
        callback(new Error('请再次输入密码'))
      } else if (value !== this.ruleForm.userPassword) {
        this.registerMsg = '两次输入的密码不一致！'
        callback(new Error('两次输入的密码不一致！'))
      } else {
        callback()
      }
    }
    var checkEmailorPhone = (rule, value, callback) => {
      const regPhone = /^(13[0-9]|15[01235-9]|17[3678]|18[0-9]|14[57])[0-9]{8}$/
      const regEmail = /^([a-zA-z]|[0-9])(\w|-)+@[a-zA-Z0-9]+(\.([a-zA-Z]+)+)$/
      if ((regPhone.test(value) && this.ruleForm.selectWay === '选项1') || (regEmail.test(value) && this.ruleForm.selectWay === '选项2')) {
        this.isLegal = true
        if (this.isTiming === false) {
          this.disabled = false
        }
        return callback()
      } else if (this.ruleForm.selectWay === '选项1') {
        this.disabled = true
        this.isLegal = false
        this.registerMsg = '手机号码格式不正确'
        callback(new Error('手机号码格式不正确'))
      } else {
        this.disabled = true
        this.isLegal = false
        this.registerMsg = '邮箱地址格式不正确'
        callback(new Error('邮箱地址格式不正确'))
      }
    }
    return {
      registerMsg: '请检查表单所填内容！',
      disabled: true,
      isTiming: false,
      isLegal: false,
      valiBtn: '获取验证码',
      regvisible: false,
      ruleForm: {
        // 测试用初始值
        selectWay: '选项1',
        userPhorEm: '',
        userName: '',
        userPassword: '',
        userRepassword: '',
        verifyCode: ''
      },
      rules: {
        selectWay: [
          { required: true, validator: checkEmailorPhone, trigger: 'input' }
        ],
        userPhorEm: [
          { required: true, validator: checkEmailorPhone, trigger: 'blur' }
        ],
        userName: [
          { required: true, message: '请输入用户账号', trigger: 'blur' },
          { min: 3, max: 15, message: '长度在 3 到 15 个字符', trigger: 'blur' }
        ],
        userPassword: [
          { required: true, message: '请输入密码', trigger: 'change' }
        ],
        userRepassword: [
          { required: true, validator: validatapass2, trigger: 'blur' }
        ]
      }
    }
  },
  methods: {
    async getVerityCode () {
      try {
        this.disabled = true
        const response = await registerService.getVerityCode({
          userName: this.ruleForm.userName,
          userPassword: this.ruleForm.userPassword,
          userPhone: this.ruleForm.selectWay === '选项1' ? this.ruleForm.userPhorEm : null,
          userEmail: this.ruleForm.selectWay === '选项2' ? this.ruleForm.userPhorEm : null,
          status: '1'
        })
        this.tackBtn()
        this.$alert(response.data.msg, '发送成功', {
          confirmButtonText: '确定',
          callback: action => {
            this.$message({
              type: 'info',
              message: `action: ${action}`
            })
          }
        })
      } catch (error) {
        if (!this.isTiming || this.isLegal) {
          this.disabled = false
        }
        if (error.response === undefined || error.response.data === undefined || typeof (error.response.data) === 'undefined') {
          this.$alert('Network Error', '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
          this.error = 'Network Error'
        } else {
          this.$alert(error.response.data.msg, '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
          this.error = error.response.data.error
        }
      }
    },
    async submitForm () {
      try {
        const response = await registerService.getVerityCode({
          userName: this.ruleForm.userName,
          userPassword: this.ruleForm.userPassword,
          userPhone: this.ruleForm.selectWay === '选项1' ? this.ruleForm.userPhorEm : null,
          userEmail: this.ruleForm.selectWay === '选项2' ? this.ruleForm.userPhorEm : null,
          verifyCode: this.ruleForm.verifyCode,
          status: '2'
        })
        console.log(response.data)
        if (response.data.code === 200) {
          this.regvisible = false
          this.$alert('您已经成功注册卡路里大作战！', '注册成功', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/login')
            }
          })
        }
        this.registerMsg = response.data.msg
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.registerMsg = '网络异常！'
          this.error = 'Network Error'
        } else {
          this.registerMsg = error.response.data.msg
          this.error = error.response.data.error
        }
      }
    },
    tackBtn: function () {
      let time = 60
      let timer = setInterval(() => {
        if (time === 0) {
          clearInterval(timer)
          this.valiBtn = '获取验证码'
          if (this.isLegal) {
            this.disabled = false
          }
          this.isTiming = false
        } else {
          this.isTiming = true
          this.disabled = true
          this.valiBtn = time + '秒后重试'
          time--
        }
      }, 1000)
    },
    toLogin: function () {
      this.$router.push('/login')
    }
  },
  watch: {
    'ruleForm.selectWay' (value) {
      this.$refs['ruleForm'].validateField('userPhorEm')
    }
  }
}
</script>

<style>
.el-header,
.el-footer {
  text-align: center;
}
.el-aside {
    display:table-cell;
    width:auto;
    background:url(../assets/food.jpg) 0 0/cover
}
.el-main {
  display:table-cell;
  width:300px;
  background-color:#fff;
  padding:40px 60px;
  color:#505e6c
}
.mlogo {
  height: 100%;
}
.el-select .el-input {
  width: 80px;
}
.input-with-select .el-input-group__prepend {
  background-color: #fff;
}
.demo-ruleForm {
  max-width: 600px;
  margin: 0 auto;
}
.register-photo
{
    height: 100%;
    background:#f1f7fc;
    padding:80px 0
}
.register-photo
{
    background:#f1f7fc;
    padding:80px 0
}
.register-photo .form-container
{
    display:table;
    max-width:900px;
    width:90%;
    margin:0 auto;
    box-shadow:1px 1px 5px rgba(0,0,0,.1)
}
.row-bg {
    padding: 10px 0;
}
</style>
